from rq_interfaces.msg import Projection, ProjectionGeometry, CheckedScanPose
from rq_interfaces.srv import AquireProjection, ReachabilityCheck
from sensor_msgs.msg import Image
from std_msgs.msg import Float64

import rclpy
from rclpy.node import Node


class BaseHardwareInterfaceService(Node):
    def __init__(self, node_name: str = 'rq_base_hardware_interface_service'):
        super().__init__(node_name)
        self.srv = self.create_service(AquireProjection, 'aquire_projection', self.aquire_projection_callback)
        self.srv = self.create_service(AquireProjection, 'reachability_check', self.reachability_check_callback)

        self.projection_publisher = self.create_publisher(Image, 'current_projection_image', 5)
        self.projection_geometry_publisher = self.create_publisher(ProjectionGeometry, 'current_projection_geometry', 5)
        self.reachabilty_publisher = self.create_publisher(CheckedScanPose, 'checked_scan_pose', 5)

    def aquire_projection_callback(self,
                                   request: AquireProjection.Request,
                                   response: AquireProjection.Response):
        raise NotImplementedError
    
    def reachability_check_callback(self,
                                    request: ReachabilityCheck.Request,
                                    response: ReachabilityCheck.Response):
        raise NotImplementedError

        

s